c
c   Least squares solution by Cholesky-Banachiewicz 
c   triangle decomposition of normal equations.
c  
c     Alex Schwarzenberg-Czerny, 
c              Astronomical Observatory of Adam Mickiewicz University,
c     Poznan,                                                            1993 
c  
c   For description see A.Schwarzenberg-Czerny, 1995, A&ASupp 110, 405
c   or paper 15 this www pages 
c
      real function cracow(en,n1,maxn1,idf,detnth)
      real en,enii,s,detnth,eniimx,eniimn,tol
      integer n1,maxn1,idf,i,j,k,l
      dimension en(maxn1,maxn1)
      data tol/5.e-8/
c  Normal equations solver
      if (n1.gt.maxn1) goto 99
      n=n1-1
      do 4 i=1,n
        enii=0.
        if (en(i,i).ge.tol) enii=1./sqrt(en(i,i))
        en(i,i)=-1.
        do 4 l=i,n+i
          j=mod(l,n1)+1
          if (l.gt.n) en(j,i+1)=0.
          en(j,i)=en(j,i)*enii 
          do 4 k=max(1,l-n),i       
 4          en(j,i+1)=en(j,i+1)-en(j,k)*en(i+1,k)
c  The equations are already solved 
c  Now square Q for inverse/covariance matrix en(n1,n1)*Q'*Q 
      en(n1,n1)=en(n1,n1)/max(1,idf)
      detnth=0.
      eniimx=en(1,1)
      eniimn=eniimx
      do 12 i=1,n
        enii=en(i,i)
        if (idf.gt.0) then
          do 10 j=1,i
            s=0.
            do 11 k=i,n
 11           s=s+en(i,k)*en(j,k)
 10         en(j,i)=s*en(n1,n1)
        endif
        if(enii.lt.0.) then
          detnth=detnth-log(-enii)
          en(n1,i)=-1./enii
        endif
        eniimx=max(enii,eniimx)
 12     eniimn=min(enii,eniimn)
      cracow=eniimx/eniimn
      detnth=exp(2.*detnth/n)
 99   end  
